package org.expeditee.io;

import java.io.IOException;
import java.util.List;

import org.expeditee.items.Dot;
import org.expeditee.items.Item;
import org.expeditee.items.Line;
import org.expeditee.items.Picture;
import org.expeditee.items.Text;

public abstract class ItemWriter {

	public static final String NEW_LINE = System.getProperty("line.separator");

	protected void writeTitle(Text toWrite, List<Item> items)
			throws IOException {
	}

	protected void writeAnnotationTitle(Text toWrite) throws IOException {
	}

	protected void writeItem(Item toWrite) throws IOException {
		if (toWrite.isAnnotation()) {
			writeAnnotationItem(toWrite);
			return;
		}

		if (toWrite instanceof Text)
			writeText((Text) toWrite);

		if (toWrite instanceof Picture)
			writePicture((Picture) toWrite);

		if (toWrite instanceof Line)
			writeLine((Line) toWrite);

		if (toWrite instanceof Dot)
			writeDot((Dot) toWrite);
	}

	protected void writeAnnotationItem(Item toWrite) throws IOException {
		if (toWrite instanceof Text)
			writeAnnotationText((Text) toWrite);

		if (toWrite instanceof Picture)
			writeAnnotationPicture((Picture) toWrite);

		if (toWrite instanceof Line)
			writeAnnotationLine((Line) toWrite);

		if (toWrite instanceof Dot)
			writeAnnotationDot((Dot) toWrite);
	}

	protected void writeAnnotationText(Text toWrite) throws IOException {
	}

	protected void writeAnnotationPicture(Picture toWrite) throws IOException {
	}

	protected void writeAnnotationLine(Line toWrite) throws IOException {
	}

	protected void writeAnnotationDot(Dot toWrite) throws IOException {
	}

	protected void writeText(Text toWrite) throws IOException {
	}

	protected void writePicture(Picture toWrite) throws IOException {
	}

	protected void writeLine(Line toWrite) throws IOException {
	}

	protected void writeDot(Dot toWrite) throws IOException {
	}

	/*
	 * public static final String NEW_LINE =
	 * System.getProperty("line.separator");
	 * 
	 * protected BufferedWriter _writer = null;
	 * 
	 * public FrameWriter(String format){}
	 * 
	 * public String initialise(String path, String filename) throws
	 * IOException{ if(path.charAt(path.length() - 1) != File.separatorChar)
	 * path += File.separator;
	 * 
	 * _writer = new BufferedWriter(new FileWriter(path.toLowerCase() +
	 * filename.toLowerCase()));
	 * 
	 * return filename; }
	 * 
	 * public void initialise(Frame toWrite) throws IOException{ String name =
	 * toWrite.getFrameset().toLowerCase(); if(name.endsWith(".")) name =
	 * name.substring(0, name.length() - 1);
	 * 
	 * String filepath = toWrite.path + name;
	 * 
	 * String filename = name + "." + toWrite.getFrameNumber();
	 * 
	 * initialise(filepath, filename); }
	 * 
	 * public void write(Frame toWrite) throws IOException{ initialise(toWrite);
	 * 
	 * writeFrame(toWrite);
	 * 
	 * finalise(); }
	 * 
	 * public void writeFrame(Frame toWrite) throws IOException{ for(Item i :
	 * toWrite.getItems()) writeItem(i, 0); }
	 * 
	 * public void writeItem(Item item, int indent) throws IOException{ if(item
	 * instanceof Text) writeText((Text) item, indent);
	 * 
	 * if(item instanceof Dot) writeDot((Dot) item);
	 * 
	 * if(item instanceof Line) writeLine((Line) item);
	 * 
	 * if(item instanceof Picture) writePicture((Picture) item); }
	 * 
	 * public void writeStartLinkItem(Item item, int indent) throws IOException{ }
	 * 
	 * public void writeEndLinkItem(Item item, int indent) throws IOException{ }
	 * 
	 * protected void writeText(Text text, int indent) throws IOException{}
	 * 
	 * protected void writeDot(Dot dot) throws IOException{}
	 * 
	 * protected void writeLine(Line line) throws IOException{}
	 * 
	 * protected void writePicture(Picture pic) throws IOException{}
	 * 
	 * public abstract void insertLine() throws IOException;
	 * 
	 * public abstract void indent() throws IOException;
	 * 
	 * public void finalise() throws IOException{ _writer.flush();
	 * _writer.close(); _writer = null; }
	 */
}
