package org.expeditee.simple;

public abstract class SPrimitive<T> extends SVariable<T> {

	public SPrimitive(String name, T value) {
		super(name, value);
	}

	public SPrimitive(T value) {
		super(null, value);
	}

	public SPrimitive() {
		super();
	}

	public Long integerValue() throws Exception {
		throw new Exception("Can not convert " + this.getClass().getName()
				+ " to Integer");
	}

	public Boolean booleanValue() throws Exception {
		throw new Exception("Can not convert " + this.getClass().getName()
				+ " to Boolean");
	}

	public Double doubleValue() throws Exception {
		throw new Exception("Can not convert " + this.getClass().getName()
				+ " to Real");
	}

	public Character characterValue() throws Exception {
		throw new Exception("Can not convert " + this.getClass().getName()
				+ " to Character");
	}

	public abstract void setValue(SPrimitive v) throws Exception;

	@Override
	public void setValue(SVariable<T> v) throws Exception {
		if (v instanceof SPrimitive) {
			setValue((SPrimitive<?>) v);
			return;
		}
		throw new Exception("Can not set primitive variable with pointer");
	}

	/**
	 * Sets the value of the primitive using a string.
	 * 
	 * @param s
	 * @throws Exception
	 */
	public abstract void parse(String s) throws Exception;
}
